"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SwaggerFilesLive = void 0;
var FileSystem = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/FileSystem"));
var Path = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/Path"));
var SwaggerRouter = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect-http/SwaggerRouter"));
var Effect = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Effect"));
var Layer = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Layer"));
var Record = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Record"));
var _swaggerUiDist = /*#__PURE__*/require("swagger-ui-dist");
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const readFile = path => Effect.flatMap(FileSystem.FileSystem, fs => fs.readFile(path));
/** @internal */
const SWAGGER_FILE_NAMES = ["index.css", "swagger-ui.css", "swagger-ui-bundle.js", "swagger-ui-standalone-preset.js", "favicon-32x32.png", "favicon-16x16.png"];
/** @internal */
const readSwaggerFile = (swaggerBasePath, file) => Effect.flatMap(Path.Path, path => readFile(path.resolve(swaggerBasePath, file)).pipe(Effect.orDie));
/** @internal */
const SwaggerFilesLive = exports.SwaggerFilesLive = /*#__PURE__*/Effect.gen(function* (_) {
  const absolutePath = (0, _swaggerUiDist.getAbsoluteFSPath)();
  const files = yield* _(SWAGGER_FILE_NAMES, Effect.forEach(path => Effect.zip(Effect.succeed(path), readSwaggerFile(absolutePath, path))), Effect.map(Record.fromEntries));
  const size = Object.entries(files).reduce((acc, [_, content]) => acc + content.byteLength, 0);
  const sizeMb = (size / 1024 / 1024).toFixed(1);
  yield* _(Effect.logDebug(`Static swagger UI files loaded (${sizeMb}MB)`));
  return {
    files
  };
}).pipe(/*#__PURE__*/Layer.effect(SwaggerRouter.SwaggerFiles));
//# sourceMappingURL=node-swagger-files.js.map