"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeRaw = exports.make = exports.handler = void 0;
var _http = /*#__PURE__*/require("http");
var NodeContext = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform-node/NodeContext"));
var NodeHttpServer = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform-node/NodeHttpServer"));
var FetchHttpClient = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/FetchHttpClient"));
var HttpClient = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/HttpClient"));
var HttpClientRequest = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/HttpClientRequest"));
var HttpServer = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("@effect/platform/HttpServer"));
var Context = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Context"));
var Deferred = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Deferred"));
var Effect = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Effect"));
var Layer = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect/Layer"));
var Client = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect-http/Client"));
var Handler = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("effect-http/Handler"));
var NodeSwaggerFiles = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("../NodeSwaggerFiles.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const defaultHttpClient = /*#__PURE__*/FetchHttpClient.layer.pipe(Layer.build, /*#__PURE__*/Effect.map(/*#__PURE__*/Context.get(HttpClient.HttpClient)), Effect.scoped, Effect.runSync);
/** @internal */
const make = (app, api, options) => startTestServer(app).pipe(Effect.map(url => Client.make(api, {
  ...options,
  httpClient: makeHttpClient(options?.httpClient ?? defaultHttpClient, url)
})), Effect.provide(NodeSwaggerFiles.SwaggerFilesLive), Effect.provide(NodeContext.layer));
/** @internal */
exports.make = make;
const makeRaw = app => startTestServer(app).pipe(Effect.map(url => makeHttpClient(defaultHttpClient, url)), Effect.provide(NodeSwaggerFiles.SwaggerFilesLive), Effect.provide(NodeContext.layer));
/** @internal */
exports.makeRaw = makeRaw;
const handler = handler => startTestServer(Handler.getRouter(handler)).pipe(Effect.map(url => makeHttpClient(defaultHttpClient, url)), Effect.provide(NodeContext.layer));
/** @internal */
exports.handler = handler;
const startTestServer = app => Effect.flatMap(Deferred.make(), allocatedUrl => serverUrl.pipe(Effect.flatMap(url => Deferred.succeed(allocatedUrl, url)), Effect.flatMap(() => Layer.launch(HttpServer.serve(app))), Effect.provide(NodeHttpServer.layer(_http.createServer, {
  port: undefined
})), Effect.forkScoped, Effect.flatMap(() => Deferred.await(allocatedUrl))));
/** @internal */
const makeHttpClient = (client, url) => client.pipe(HttpClient.mapRequest(HttpClientRequest.prependUrl(url)), HttpClient.transformResponse(Effect.mapInputContext(ctx => {
  const init = ctx.unsafeMap.get(FetchHttpClient.RequestInit.key) ?? {};
  return Context.add(ctx, FetchHttpClient.RequestInit, {
    keepalive: false,
    ...init
  });
})));
/** @internal */
const serverUrl = /*#__PURE__*/Effect.map(HttpServer.HttpServer, server => {
  const address = server.address;
  if (address._tag === "UnixAddress") {
    return address.path;
  }
  return `http://localhost:${address.port}`;
});
//# sourceMappingURL=node-testing.js.map