import * as NodeContext from "@effect/platform-node/NodeContext";
import * as NodeHttpServer from "@effect/platform-node/NodeHttpServer";
import * as HttpServer from "@effect/platform/HttpServer";
import * as Effect from "effect/Effect";
import { pipe } from "effect/Function";
import * as Layer from "effect/Layer";
import { createServer } from "http";
import * as NodeSwaggerFiles from "../NodeSwaggerFiles.js";
/** @internal */
const DEFAULT_LISTEN_OPTIONS = {
  port: undefined
};
/** @internal */
export const listen = options => router => pipe(HttpServer.logAddress, Effect.flatMap(() => Layer.launch(HttpServer.serve(router))), Effect.scoped, Effect.provide(NodeHttpServer.layer(() => createServer(), {
  ...DEFAULT_LISTEN_OPTIONS,
  ...options
})), Effect.provide(NodeSwaggerFiles.SwaggerFilesLive), Effect.provide(NodeContext.layer));
//# sourceMappingURL=node-server.js.map